"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const glob = require("fast-glob");
const __1 = require("..");
ava_1.default('adds new source files', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const compiler = new __1.Compiler();
    yield compiler.source('./src/tests/assets/*.sol');
    const files = Object.keys(compiler.input.sources);
    t.deepEqual(files, [
        './src/tests/assets/interface.sol',
        './src/tests/assets/token-a.sol',
        './src/tests/assets/token-b.sol',
        './src/tests/assets/token-c.sol',
    ]);
}));
ava_1.default('compiles source files', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const compiler = new __1.Compiler();
    yield compiler.source('./src/tests/assets/*.sol');
    yield compiler.compile();
    const contracts = Object.keys(compiler.output.contracts);
    t.deepEqual(contracts, [
        './src/tests/assets/interface.sol',
        './src/tests/assets/token-a.sol',
        './src/tests/assets/token-b.sol',
        './src/tests/assets/token-c.sol',
    ]);
}));
ava_1.default('cleans compiled output', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const compiler = new __1.Compiler();
    yield compiler.source('./src/tests/assets/*.sol');
    yield compiler.compile();
    compiler.clean();
    Object.keys(compiler.output.contracts).forEach((element) => {
        t.is(Object.keys(compiler.output.contracts[element]).length, 1);
    });
}));
ava_1.default('saves compiled sources to destination', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const compiler = new __1.Compiler();
    yield compiler.source('./src/tests/assets/*.sol');
    yield compiler.compile();
    compiler.save('./build/foo');
    const files = glob.sync('./build/foo/*.json');
    t.deepEqual(files, [
        './build/foo/interface.json',
        './build/foo/token-a.json',
        './build/foo/token-b.json',
        './build/foo/token-c.json',
    ]);
}));
//# sourceMappingURL=compiler.test.js.map